#include "Bestenliste.h"


Bestenliste::Bestenliste( int id )
    : Variable( BESTENLISTE )
{
    this->id = id;
    sichtbar = 1;
}

void Bestenliste::setSichtbar( bool sichtbar )
{
    this->sichtbar = sichtbar;
}

void Bestenliste::addSpalte( const char* name )
{
    spalten.add( new Text( name ) );
}

void Bestenliste::addZeile( const char* name )
{
    zeilen.add( new Text( name ) );
}

void Bestenliste::setWert( const char* spalte, const char* zeile, const char* wert )
{
    int spalteI = 0;
    for( auto s = spalten.begin(); s; s++, spalteI++ )
    {
        if( s->istGleich( spalte ) )
            break;
    }
    int zeileI = 0;
    for( auto z = zeilen.begin(); z; z++, zeileI++ )
    {
        if( z->istGleich( zeile ) )
            break;
    }
    if( !werte.z( zeileI ) )
        werte.set( new RCArray< Text >(), zeileI );
    werte.z( zeileI )->set( new Text( wert ), spalteI );
}

const char* Bestenliste::getWert( const char* spalte, const char* zeile )
{
    int spalteI = 0;
    for( auto s = spalten.begin(); s; s++, spalteI++ )
    {
        if( s->istGleich( spalte ) )
            break;
    }
    int zeileI = 0;
    for( auto z = zeilen.begin(); z; z++, spalteI++ )
    {
        if( z->istGleich( zeile ) )
            break;
    }
    if( !werte.z( zeileI ) || !werte.z( zeileI )->hat( spalteI ) )
        return "";
    return werte.z( zeileI )->z( spalteI )->getText();
}