#pragma once

#include <Datei.h>
#include <Vec2.h>
#include "Team.h"
#include "SpielKlasse.h"

class Spiel;
class Aktion;

struct SpielerTeamStruktur
{
	int spielerAnzahl;
	int teamAnzahl;
	Array< int > spielerFarbe;
	Array< int > teamFarbe;
	RCArray< Text > teamName;
	Array< int > teamSize;
};

class MapReader : public virtual ReferenceCounter
{
private:
	SSDatenbankV* db;
	Text* pfad;
	int karteId;

public:
	// Konstruktor
	MapReader(int karteId, SSDatenbankV* db, const char* tmpPfad);
	MapReader();
	// Destruktor
	~MapReader();
	// nicht constant
	void ladeKarte(Spiel* zSpiel);
	Aktion* readAktion(Datei& dat);
	void writeAktion(Aktion* zAk, Datei& dat);
	//void writeAktion( Aktion *ak, Datei &dat );
};