#pragma once

#include <Array.h>
#include <Vec2.h>
#include <ReferenceCounter.h>
#include "SSKlientV.h"

class Spieler;
class Team;

class Klient : public virtual Framework::ReferenceCounter
{
private:
	SSKlientV* klient;

public:
	// Konstruktor
	Klient(SSKlientV* klient);
	// Destruktor
	~Klient();
	// nicht constant
	void offline();
	void online(SSKlientV* zKlient);
	void sendeInit(RCArray< Spieler >* zSpieler, __int64 seed);
	void sendeSpielerNummer(int sNum);
	void sendeStart();
	void sendeTastaturStatus(int spielerId, char taste, bool aktiv);
	void sendeSpielEnde(char gewonnen);
	void sendeTick();
	void sendeChatNachricht(const char* txt);
	void sendeStatistikChatNachricht(int vonAccount, const char* txt);
	void sendeStatistikSpielerOffline(int account);
	void sendeSpielerStatistik(Spieler* zS);
	void sendeTeamStatistik(Team* zS);
	void sendeStatistikLadenFertig();
	// constant
	bool istOnline() const;
};